=== debian/changelog ===
grib-api (1.25.0-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.1.2; no changes required

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 03 Jan 2018 12:34:33 +0000
